#version 120
//#pragma optionNV(ifcvt none)
//#pragma optionNV(fastmath on)
//#pragma optionNV(fastprecision on)
//#pragma optionNV(unroll all)
//#pragma optionNV(strict on)
#define SPLATS_NOT_SPRITES

varying float cameraDistance;
varying vec3 normal;
varying vec3 orig_Position;
varying vec3 xWorld;
varying vec3 yWorld;
uniform vec3 camPos;
varying float adaptiveRadius;
uniform float radius;
uniform float depthOffset;
//in vec3 fColor;

void main()
{
	float texX = gl_TexCoord[0].x * 2.0 - 1.0;
	float texY = - gl_TexCoord[0].y * 2.0 + 1.0;
	
	vec3 rayVector1 = orig_Position + xWorld * texX + yWorld * texY - camPos;   
	vec3 worldCoords = camPos + rayVector1 * cameraDistance / dot(rayVector1, normal);
	float dist = length(worldCoords - orig_Position);
		
	//FILTER NI VEČ POMEMBEN?
#ifdef SPLATS_NOT_SPRITES
	if (dist > adaptiveRadius)// && (texX * texX + texY * texY) > 1.0)// || (dist>radius && ((texX * texX + texY * texY) > (1.0/radius)*(1.0/radius))))
#else
	if ((texX * texX + texY * texY) > 1.0)
#endif
	{
		discard;
	}
	else
	{	
		//gl_FragData[0] = vec4(normal*weight, 0.5);
		//gl_FragData[1] = vec4(gl_Color.xyz*weight, 0.5);
#ifdef SPLATS_NOT_SPRITES
			vec4 vector = gl_ModelViewProjectionMatrix * vec4(worldCoords,1.0);
			float depth = vector.z/vector.w;			
			float zPos = 0.5 * depth + 0.5;
			gl_FragDepth = zPos;
			
			dist = dist/adaptiveRadius;
			float weight = exp(-dist * dist / 0.18);
			//float weight = (adaptiveRadius - dist) / adaptiveRadius;
			gl_FragData[0].xyz = normal*weight;
#else
			gl_FragData[0].xyz = normal;
#endif
		
#ifndef EXCLUDE_COLORS
			//*weight;
	#ifdef SPLATS_NOT_SPRITES
				gl_FragData[1].xyz = gl_Color.rgb*weight;
				gl_FragData[1].w = weight;
	#else
				gl_FragData[1].xyz = gl_Color.rgb;
				gl_FragData[1].w = 1.0;
	#endif
#endif
		//gl_FragData[0].xyz = normal;
		//gl_FragData[1].xyz = gl_Color.rgb;
	}
}
