#version 120

uniform vec3 camPos;
uniform sampler2D normalTex;	//normals
//uniform sampler2D depthTex;	//depth
#ifndef EXCLUDE_COLORS
	uniform sampler2D colorTex;	//colors
#endif
uniform mat4 inverseM;
uniform float radius;
uniform float weightModifier;
uniform float drawMode;
uniform float contrast;
uniform float brightness;
uniform float viewportWidth;
uniform float viewportHeight;

void main()
{			
	//retrieve summed normals from attribute pass and normalize
	vec4 summedNormals = texture2D(normalTex,vec2(gl_FragCoord.x/viewportWidth, gl_FragCoord.y/viewportHeight));
	float normalLength = length(summedNormals.xyz);
	if (normalLength == 0.0)
	{
		//gl_FragColor = vec4(1.0,1.0,1.0,1.0);
		gl_FragData[0].xyz = vec3(0.0,0.0,0.0);
		#ifndef EXCLUDE_COLORS
			gl_FragData[1].rgb = vec3(0.0,0.0,0.0);
		#endif
	}
	else
	{
		gl_FragData[0].xyz  = summedNormals.xyz / normalLength;
		#ifndef EXCLUDE_COLORS
			vec4 summedColors = texture2D(colorTex,vec2(gl_FragCoord.x/viewportWidth, gl_FragCoord.y/viewportHeight));
			gl_FragData[1].rgb  = summedColors.rgb / summedColors.w;
		#endif	
		//gl_FragData[1].rgb  = vec3(0.0,1.0,1.0);
	}
	//gl_FragData[0].xyz  = summedNormals.xyz;
	//gl_FragData[1].rgb  = summedColors.rgb;
}
