#version 120
//#pragma optionNV(ifcvt none)
//#pragma optionNV(fastmath on)
//#pragma optionNV(fastprecision on)
//#pragma optionNV(unroll all)
//#pragma optionNV(strict on)

varying float cameraDistance;
varying vec3 normal;
varying vec3 orig_Position;
varying vec3 xWorld;
varying vec3 yWorld;
uniform vec3 camPos;
uniform mat4 mvProj;
varying float adaptiveRadius;
uniform float radius;
//uniform float depthOffset;

void main()
{
	float texX = gl_TexCoord[0].x * 2.0 - 1.0;
	float texY = - gl_TexCoord[0].y * 2.0 + 1.0;
	
	vec3 rayVector1 = orig_Position + xWorld * texX + yWorld * texY - camPos;
	//vec3 rayVector1 = orig_Position.xyz - camPos;
	vec3 worldCoords = camPos + rayVector1 * cameraDistance / dot(rayVector1, normal);
	
	float dist = length(worldCoords - orig_Position);

	worldCoords = worldCoords + normalize(worldCoords - camPos)*adaptiveRadius;//*depthOffset;	//offset away from camera
	//worldCoords = worldCoords + normalize(worldCoords - camPos)*radius;//*depthOffset;	//offset away from camera
		
		//gl_FragDepth = 0.5;
		
	if (dist > adaptiveRadius)// && (texX * texX + texY * texY) > 1.0)
	//if (dist > radius)
	{
		discard;
	}
	else
	{		
		vec4 vector = gl_ModelViewProjectionMatrix * vec4(worldCoords.xyz, 1.0); 
		float depth = vector.z/vector.w;
		//float depth = vz/vw;
		float zPos = 0.5 * depth + 0.5;
		gl_FragDepth = zPos;			
		//gl_FragDepth = 0.0;
	}
}
